#include <cstdlib>
#include <iostream>
#include <cmath>
#include <fstream>
#include <conio.h>
#include <string>
#include "tab.h"

using namespace std;

int IsoelectricPoint()
{
      std::string protein;
          ifstream aa;
       aa.open("aa.txt");        //we are getting the data from the file (we assume that we have aa.txt file)
       aa>>protein;                //the sequence should be in one letter code (uppercase letters)
   	    aa.close();
   	   
 int ProtLength;               //obliczamy dugo naszego biaka
   ProtLength = protein.length();
   
   
   char Asp = 'D';
   char Glu = 'E';
   char Cys = 'C';
   char Tyr = 'Y';
   char His = 'H';
   char Lys = 'K';
   char Arg = 'R';

int AspNumber = 0;
int GluNumber = 0;
int CysNumber = 0;
int TyrNumber = 0;
int HisNumber = 0;
int LysNumber = 0;
int ArgNumber = 0;

int i=0;


for ( i = 0; i <= protein.length() - 1; ++i)
    {
              if (protein[i] == Asp)
                 ++AspNumber;

              if (protein[i] == Glu)
                 ++GluNumber;

              if (protein[i] == Cys)
                 ++CysNumber;

              if (protein[i] == Tyr)
                 ++TyrNumber;

              if (protein[i] == His)
                 ++HisNumber;

              if (protein[i] == Lys)
                 ++LysNumber;

              if (protein[i] == Arg)
                 ++ArgNumber;
    }
    
    double QN1=0;  //C-terminal charge
    double QN2=0;  //D charge
    double QN3=0;  //E charge
    double QN4=0;  //C charge
    double QN5=0;  //Y charge
    double QP1=0;  //H charge
    double QP2=0;  //NH2 charge
    double QP3=0;  //K charge
    double QP4=0;  //R charge
    
    double NQ = 0.0;             //net chare in given pH
    double pH = 6.5;             //starting point pI = 6.5 - theoretically it sould be 7, but
                                 //average protein pI is 6.5 so we increase the probability
    double pHprev = 0.0;         //of finding the solution
    double pHnext = 14.0;        //0-14 is possible pH range    
    
    double X = 0.0;
    double E = 0.01;             //epsilon means precision [pI = pH  E]
    double temp = 0.0;
	int tabl = 650;				 
	 
	i=0;
cout<<"***************************************************************"<<endl;
cout<<"**                   Lukasz Kozlowski 2007                   **"<<endl;
cout<<"**                                                           **"<<endl;
cout<<"**        Program to calculation of isoelectric point        **"<<endl;
cout<<"**                 (using bisection method)                  **"<<endl;
cout<<"***************************************************************"<<endl;  
cout<<endl<<endl;
    
for(;;)
{

    QN1=tab[tabl][0];
    QN2=-AspNumber/tab[tabl][1];
    QN3=-GluNumber/tab[tabl][2];
    QN4=-CysNumber/tab[tabl][3];
    QN5=-TyrNumber/tab[tabl][4];
    QP1=HisNumber/tab[tabl][5];
    QP2=tab[tabl][6];
    QP3=LysNumber/tab[tabl][7];
    QP4=ArgNumber/tab[tabl][8];

    NQ=QN1+QN2+QN3+QN4+QN5+QP1+QP2+QP3+QP4;
        cout<<"NQ="<<NQ<<"\tat pH ="<<pH<<"\ti:" <<i++<<endl;
        
/*We determine protein pI, the above equation behave in such a manner: first in low pH we NQ>0
and while we are incresing pH it decrease. When it reach zero the isoelectric point will be find.
In fact, this is how acts the naive algorithm, but it is very unefficent. For example, if analized
protein pI=8.65, it means that NQ will be calculated 865 times (0.01 precision). Due this a naive 
algorithm consumes lots of time. If we are calculating pI only once it is of no importance, but in
other cases, such an approach to the issue is inefficient. To speed up the calculation of pI we 
use method so-called bisection. Additionally, the usage of appropriate array gives more speed 
improvments (see tab.h)*/


//%%%%%%%%%%%%%%%%%%%%%%%%%   BISECTION   %%%%%%%%%%%%%%%%%%%%%%%%

    if(NQ<0)              //we are out of range, thus the new pH value must be smaller    
     {                   
        temp = pH;
        pH = pH-((pH-pHprev)/2);
        pHnext = temp;
        cout<<"pH: "<<pH<<", \tpHnext: "<<pHnext<<endl;
    }
    else                  //we used to small pH value, so we have to increase it
    {                     
        temp = pH;
        pH = pH + ((pHnext-pH)/2);
        pHprev = temp;
        cout<<"pH: "<<pH<<",\tpHprev: "<<pHprev<<endl;
 
    }

 if ((pH-pHprev<E)&&(pHnext-pH<E)) //terminal condition, finding pI with given precision
          break;
   
//conclusions: thanks to bisection we could shorten the calculation to 10-12 iterations!!!



//%%%%%%%%%%%%%%%%%%%   cutting off pH to two decimals   %%%%%%%%%%%%%%%%%%%
	double ulamek;
   double n = pH * 100;
   int obc;
obc = static_cast<int>(n);     //projection double to int
   ulamek = n - obc;
		if(ulamek >= 0.5)
         obc++; 
tabl = obc;
pH = static_cast<double>(obc); //after that we are move to double again        
    pH = pH /100;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 if (pH>=14.0)
   {                                                 //you should never see this message
  cout<<"Something is wrong - pH is higher than 14"<<endl;  
   break;                                            
   }     
 }
ofstream outfile;                //we are writting results to outfile.txt
 outfile.open("outfile.txt"); 
   outfile << "***************************************************************"<<endl;
   outfile << "**                   Lukasz Kozlowski 2007                   "<<endl;
   outfile << "**                                                           "<<endl;
   outfile << "**        Program to calculation of isoelectric point        "<<endl;
   outfile << "**                 (using bisection method)                  "<<endl;
   outfile << "***************************************************************"<<endl<<endl;          
   outfile << "Protein length: "<<ProtLength<<endl;
   outfile << "Number of Asp = "<<AspNumber<<endl;  
   outfile << "Number of Glu = "<<GluNumber<<endl;
   outfile << "Number of Cys = "<<CysNumber<<endl;
   outfile << "Number of Tyr = "<<TyrNumber<<endl;
   outfile << "Number of His = "<<HisNumber<<endl;
   outfile << "Number of Lys = "<<LysNumber<<endl;
   outfile << "Number of Arg = "<<ArgNumber<<endl;
   outfile << "Protein  isoelectric point: "<<pH<<endl;
 outfile.close();
   cout <<endl<< "Protein isoelectric point: "<<pH<<endl<<endl;
       return 0;
}
